#Completed in R version 4.2.1 (2022-06-23 ucrt) [platform: x86_64-w64-mingw32]
#Including the following packages:
library(dplyr) #package version 1.0.10
library(reshape2) #package version 1.4.4
library(ggplot2) #package version 3.3.6

#2.4. Figure 1

##Dataframe for Figure 1
F1data <- aggregate(cogbattery_w8 ~ agecat_w8 + educationcat_w8, data = studysample2, FUN = length)
F1data$mci_cutoff <- aggregate(cogbattery_w8 ~ agecat_w8 + educationcat_w8, data = studysample2, FUN = mean)[,3]-aggregate(cogbattery_w8 ~ agecat_w8 + educationcat_w8, data = studysample2, FUN = sd)[,3]
F1data$dementia_cutoff <- aggregate(cogbattery_w8 ~ agecat_w8 + educationcat_w8, data = studysample2, FUN = mean)[,3]-2*aggregate(cogbattery_w8 ~ agecat_w8 + educationcat_w8, data = studysample2, FUN = sd)[,3]
F1data <- data.frame(edu = F1data$educationcat_w8,
                 age = F1data$agecat_w8,
                 Dementia = floor(F1data$dementia_cutoff), 
                 MCI = floor(F1data$mci_cutoff)-floor(F1data$dementia_cutoff),
                 NC = 16 - floor(F1data$mci_cutoff))
F1data$age[F1data$age == 1] <- '65–74 years'; F1data$age[F1data$age == 2] <- '75–84 years'; F1data$age[F1data$age == 3] <- '≥85 years'
F1data$edu[F1data$edu == 1] <- 'low education'; F1data$edu[F1data$edu == 2] <- 'medium education'; F1data$edu[F1data$edu == 3] <- 'high education'
F1data$group <- factor(paste0(F1data$edu, ",\n ", F1data$age), levels=c('low education,\n ≥85 years', 'low education,\n 75–84 years', 'low education,\n 65–74 years',
                                                                           'medium education,\n ≥85 years', 'medium education,\n 75–84 years', 'medium education,\n 65–74 years',
                                                                           'high education,\n ≥85 years', 'high education,\n 75–84 years', 'high education,\n 65–74 years'))
F1data <- melt(F1data[3:6], id = c('group'))
F1data$names <- factor(c(rep("Dementia", 9), rep("MCI", 9), rep("NC/SMC", 9)), levels=c('NC/SMC', 'MCI', 'Dementia'))

#Plot
png("output/Figure_1.png", units="cm", width=25, height=18, res=600)
ggplot(data=F1data, aes(fill = names, x=group, y=value)) +
  geom_bar(stat="identity")+
  scale_fill_manual(values=c('lightgreen', 'blue', 'red'))+
  labs(x=NULL, y="Cognitive battery score", fill = NULL)+
  scale_y_continuous(limits = c(0, 16), breaks = seq(0, 16, 1))+ 
  theme(legend.position="top")
dev.off()
