#Completed in R version 4.2.1 (2022-06-23 ucrt) [platform: x86_64-w64-mingw32]
#Including the following package:
library("psych") #package version 2.2.5

#3.3. SHARE-Cog Items and Internal Consistency

##Custom fucntion to return Cronbach's alpha
alphavalue <- function(cordata) {alpha1 <- psych::alpha(cordata)
return(alpha1[["total"]][["raw_alpha"]])}

##Descriptive statistics for SHARE-Cog subtest variables 
round(mean(sample_primary$wreg10_w8), 2); round(sd(sample_primary$wreg10_w8), 2)
max(sample_primary$wreg10_w8); quantile(sample_primary$wreg10_w8, 0.99)

round(mean(sample_primary$fluency_w8), 2); round(sd(sample_primary$fluency_w8), 2)
max(sample_primary$fluency_w8); quantile(sample_primary$fluency_w8, 0.99)

round(mean(sample_primary$recall10_w8), 2); round(sd(sample_primary$recall10_w8), 2)
max(sample_primary$recall10_w8); quantile(sample_primary$recall10_w8, 0.99)

##Descriptive statistics for SHARE-Cog subtests (weighted scores)
round(mean(sample_primary$wreg10_w8), 2); round(sd(sample_primary$wreg10_w8), 2)
round(mean(round(0.5*pmin(sample_primary$fluency_w8,30))), 2); round(sd(round(0.5*pmin(sample_primary$fluency_w8,30))), 2)
round(mean(2*sample_primary$wreg10_w8), 2); round(sd(2*sample_primary$wreg10_w8), 2)

##Descriptive statistics for overall SHARE-Cog score
round(mean(sample_primary$sharecog_w8), 2); round(sd(sample_primary$sharecog_w8), 2)
max(sample_primary$sharecog_w8); quantile(sample_primary$sharecog_w8, 0.99)

##Correlation between SHARE-Cog subtests
cordata <- data.frame(wreg=sample_primary$wreg10_w8*1, vfluency=round(pmin(sample_primary$fluency_w8,30)*0.5), recall=sample_primary$recall10_w8*2)
round(cor(cordata),2)

##Internal consistency of the SHARE-Cog subtests
cordata <- data.frame(wreg=sample_primary$wreg10_w8*1, vfluency=round(pmin(sample_primary$fluency_w8,30)*0.5), recall=sample_primary$recall10_w8*2)
round(alphavalue(cordata), 2)
