#Completed in R version 4.2.1 (2022-06-23 ucrt) [platform: x86_64-w64-mingw32]
#Including the following package:
library(pROC) #package version 1.18.0

#3.4. Table S5

##Calculation of ROC curves (primary analysis)
roc1 <- roc(studysample2$D_MCI_v_SMC_NC, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc2 <- roc(studysample2$D_MCI_v_NC, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc3 <- roc(studysample2$MCI_v_D, studysample2$sharecog_w8, direction=">", levels=c(1, 0))
roc4 <- roc(studysample2$MCI_v_SMC_NC, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc5 <- roc(studysample2$MCI_v_NC, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc6 <- roc(studysample2$D_v_MCI_SMC_NC, studysample2$sharecog_w8, direction="<", levels=c(1, 0))

##Calculation of ROC curves (sensitivity analysis 1)
roc1_S1 <- roc(studysample2$D_MCI_v_SMC_NC_S1, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc2_S1 <- roc(studysample2$D_MCI_v_NC_S1, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc3_S1 <- roc(studysample2$MCI_v_D_S1, studysample2$sharecog_w8, direction=">", levels=c(1, 0))
roc4_S1 <- roc(studysample2$MCI_v_SMC_NC_S1, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc5_S1 <- roc(studysample2$MCI_v_NC_S1, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc6_S1 <- roc(studysample2$D_v_MCI_SMC_NC_S1, studysample2$sharecog_w8, direction="<", levels=c(1, 0))

##Calculation of ROC curves (sensitivity analysis 2)
roc1_S2 <- roc(studysample2$D_MCI_v_SMC_NC_S2, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc2_S2 <- roc(studysample2$D_MCI_v_NC_S2, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc3_S2 <- roc(studysample2$MCI_v_D_S2, studysample2$sharecog_w8, direction=">", levels=c(1, 0))
roc4_S2 <- roc(studysample2$MCI_v_SMC_NC_S2, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc5_S2 <- roc(studysample2$MCI_v_NC_S2, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc6_S2 <- roc(studysample2$D_v_MCI_SMC_NC_S2, studysample2$sharecog_w8, direction="<", levels=c(1, 0))

##Calculation of ROC curves (sensitivity analysis 3)
roc1_S3 <- roc(studysample2$D_MCI_v_SMC_NC_S3, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc2_S3 <- roc(studysample2$D_MCI_v_NC_S3, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc3_S3 <- roc(studysample2$MCI_v_D_S3, studysample2$sharecog_w8, direction=">", levels=c(1, 0))
roc4_S3 <- roc(studysample2$MCI_v_SMC_NC_S3, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc5_S3 <- roc(studysample2$MCI_v_NC_S3, studysample2$sharecog_w8, direction="<", levels=c(1, 0))
roc6_S3 <- roc(studysample2$D_v_MCI_SMC_NC_S3, studysample2$sharecog_w8, direction="<", levels=c(1, 0))

##Table S5 Numbers in each cognitive subgroup 
Table_S5a <- cbind(
  primary = summary(as.factor(na.omit(studysample2$cognitivegroups_w8))),
  S1 = summary(as.factor(na.omit(studysample2$cognitivegroupsS1_w8))),
  S2 = summary(as.factor(na.omit(studysample2$cognitivegroupsS2_w8))),
  S3 = summary(as.factor(na.omit(studysample2$cognitivegroupsS3_w8)))
)

##Table S5 Diagnostic accuracy
Table_S5b <- 
  data.frame(
    primary = c(
      paste0(round(ci.auc(roc1)[2], 2), " (", round(ci.auc(roc1)[1], 2), "–", round(ci.auc(roc1)[3], 2),")"),
      paste0(round(ci.auc(roc2)[2], 2), " (", round(ci.auc(roc2)[1], 2), "–", round(ci.auc(roc2)[3], 2),")"),
      paste0(round(ci.auc(roc3)[2], 2), " (", round(ci.auc(roc3)[1], 2), "–", round(ci.auc(roc3)[3], 2),")"),
      paste0(round(ci.auc(roc4)[2], 2), " (", round(ci.auc(roc4)[1], 2), "–", round(ci.auc(roc4)[3], 2),")"),
      paste0(round(ci.auc(roc5)[2], 2), " (", round(ci.auc(roc5)[1], 2), "–", round(ci.auc(roc5)[3], 2),")"),
      paste0(round(ci.auc(roc6)[2], 2), " (", round(ci.auc(roc6)[1], 2), "–", round(ci.auc(roc6)[3], 2),")")),
    S1 = c(
      paste0(round(ci.auc(roc1_S1)[2], 2), " (", round(ci.auc(roc1_S1)[1], 2), "–", round(ci.auc(roc1_S1)[3], 2),")"),
      paste0(round(ci.auc(roc2_S1)[2], 2), " (", round(ci.auc(roc2_S1)[1], 2), "–", round(ci.auc(roc2_S1)[3], 2),")"),
      paste0(round(ci.auc(roc3_S1)[2], 2), " (", round(ci.auc(roc3_S1)[1], 2), "–", round(ci.auc(roc3_S1)[3], 2),")"),
      paste0(round(ci.auc(roc4_S1)[2], 2), " (", round(ci.auc(roc4_S1)[1], 2), "–", round(ci.auc(roc4_S1)[3], 2),")"),
      paste0(round(ci.auc(roc5_S1)[2], 2), " (", round(ci.auc(roc5_S1)[1], 2), "–", round(ci.auc(roc5_S1)[3], 2),")"),
      paste0(round(ci.auc(roc6_S1)[2], 2), " (", round(ci.auc(roc6_S1)[1], 2), "–", round(ci.auc(roc6_S1)[3], 2),")")),
    S2 = c(
      paste0(round(ci.auc(roc1_S2)[2], 2), " (", round(ci.auc(roc1_S2)[1], 2), "–", round(ci.auc(roc1_S2)[3], 2),")"),
      paste0(round(ci.auc(roc2_S2)[2], 2), " (", round(ci.auc(roc2_S2)[1], 2), "–", round(ci.auc(roc2_S2)[3], 2),")"),
      paste0(round(ci.auc(roc3_S2)[2], 2), " (", round(ci.auc(roc3_S2)[1], 2), "–", round(ci.auc(roc3_S2)[3], 2),")"),
      paste0(round(ci.auc(roc4_S2)[2], 2), " (", round(ci.auc(roc4_S2)[1], 2), "–", round(ci.auc(roc4_S2)[3], 2),")"),
      paste0(round(ci.auc(roc5_S2)[2], 2), " (", round(ci.auc(roc5_S2)[1], 2), "–", round(ci.auc(roc5_S2)[3], 2),")"),
      paste0(round(ci.auc(roc6_S2)[2], 2), " (", round(ci.auc(roc6_S2)[1], 2), "–", round(ci.auc(roc6_S2)[3], 2),")")),
    S3 = c(
      paste0(round(ci.auc(roc1_S3)[2], 2), " (", round(ci.auc(roc1_S3)[1], 2), "–", round(ci.auc(roc1_S3)[3], 2),")"),
      paste0(round(ci.auc(roc2_S3)[2], 2), " (", round(ci.auc(roc2_S3)[1], 2), "–", round(ci.auc(roc2_S3)[3], 2),")"),
      paste0(round(ci.auc(roc3_S3)[2], 2), " (", round(ci.auc(roc3_S3)[1], 2), "–", round(ci.auc(roc3_S3)[3], 2),")"),
      paste0(round(ci.auc(roc4_S3)[2], 2), " (", round(ci.auc(roc4_S3)[1], 2), "–", round(ci.auc(roc4_S3)[3], 2),")"),
      paste0(round(ci.auc(roc5_S3)[2], 2), " (", round(ci.auc(roc5_S3)[1], 2), "–", round(ci.auc(roc5_S3)[3], 2),")"),
      paste0(round(ci.auc(roc6_S3)[2], 2), " (", round(ci.auc(roc6_S3)[1], 2), "–", round(ci.auc(roc6_S3)[3], 2),")"))
    )
